Version 8.4.0 (Kintsugi Radiance)
---------------------------------
[New] Add fMP4 Muxing Options for web playback streaming (disabled by default)
[Fixed] Corrected video/audio encoding settings to ensure correct preset, quality, and filter application.
[Fixed] Addressed potential issues with missing codec selections.
[Fixed] Improved UI handling of encoding settings when changing presets.
[Fixed] Drag n Drop now support reads from folders.
[Update] Refactored video and audio queue handling to directly initialize objects instead of relying on MediaQueueParse.
[Update] Optimized encoder settings management for video and audio, reducing unnecessary assignments.
[Update] Removed unused using directives (System.Net.Http.Headers, System.Collections).
[Update] Enhanced display logic for supported codecs with better dictionary handling.
[Update] Improved how FFmpeg filter and encoder commands are stored and applied.
[Update] Introduced ImportFiles function to streamline file imports with a progress bar.
[Update] Updated drag-and-drop and menu-based file import to use the new ImportFiles function, improving performance and UI responsiveness.
[Update] Refactored how codec selection and UI updates handle missing or unsupported codecs.
[Update] Removed redundant functions such as LoadControlVideo, LoadControlAudio, SaveControlVideo, and SaveControlAudio.
[Update] FFmpeg updated to git-2025-04-13-bf327ac, GCC 10.2.
[Update] Rigaya NVEnc updated to 7.83.
[Update] Rigaya QSVEnc updated to 7.86.
[Update] x265 AVX2 updated to 4.1+1-32e25ff, GCC 14.2.
[Update] uvg266 updated to 0.8.1-cf31e82, GCC 14.2.
[Update] vvenc updated to 1.13.0, GCC 14.2.

Version 8.3.8 ( -KIZUGUCHI- )
-----------------------------
[Fixed] Parser input output CSP

Version 8.3.7 ( -KIZUGUCHI- )
-----------------------------
[New] Add Rigaya Intel Quick Sync Hardware Encoder (h264, hevc, av1)
[Fixed] FFmpeg Metadata file must be at index 0
[Fixed] Clear encoder args when user change encoder after selecting Profile
[Fixed] Slow encoding performance on Rigaya NVEnc when pipe from FFmpeg, now Rigaya NVEnc decode and encode (no pipe)
[Fixed] Improve GUI responsive
[Update] Improve performance on removing items
[Update] Rigaya NVEnc to 7.64

Version 8.3.6 (Enduring Fortitude)
----------------------------------
[Fixed] GUI crashed when trying to display settings due to race condition between threads

Version 8.3.5 (Resilient Journey)
---------------------------------
[Fixed] #242: Bug on creating and loading profile

Version 8.3.4 (Celestial Rhapsody)
----------------------------------
[Fixed] Queue consistency check code caused an invalid index crash; the outdated code has been removed.
[Fixed] When adding a subtitle, the selected language will be used if a language code is not found in the file name.

Version 8.3.3 (Luminous Veil)
-----------------------------
[Fixed] Add another file when selected profile is blank cause a crash 
[Update] FFmpeg (Non-Free build) updated to version git-2024-07-07-0619138.

Version 8.3.2 (Astral Reverie)
------------------------------
[New] Added ETA in Progress status.
[New] Main list columns are now adaptive, automatically resizing based on window size and DPI settings.
[Fixed] Selecting a profile no longer causes a crash due to a null value.
[Fixed] Custom FFmpeg commands and encoder commands now persist after selecting a profile.
[Fixed] Resolved encoding crashes when using Auto Resolution, Auto FPS, and Auto Frame Count.
[Update] Rigaya H264/265 NVENC updated to version 7.57.
[Update] FFmpeg (Non-Free build) updated to version git-2024-07-07-cd2f8a2.
[Update] x265 (AVX2) updated to version 3.6+33-ad1a30a8a.

Version 8.3.1 (Stellar Dreamscape)
----------------------------------
[New] Added a "Profiles" tab in the Options window to display available encoding profiles, including author details and their website.
[Fixed] Resolved a crash when adding an audio file with MKV as the output format and then switching to an audio-only format (e.g., MP3).
[Fixed] Album art is now correctly processed and re-muxed during the final output process.
[Fixed] Metadata is now accurately processed and forwarded to the encoded file.
[Fixed] Enhanced user profiles to allow saving and loading of custom profiles.
[Update] Plug-ins can now use executables from the system PATH by default. For example, if x265.exe exists in both the PATH and the Plugins folder, the PATH version will be used.
[Update] FFmpeg and MP4Box will now use the system PATH by default if available, falling back to the bundled versions if not found.
[Update] Improved the Audio Plugin JSON file format for greater robustness and support for custom commands.
[Update] Added support for MPG/MPEG (VCD/DVD) and WMV (with WMA) formats, ensuring compatibility with older operating systems like Windows XP and applications such as Microsoft Office PowerPoint.

Version 8.3.0 (Radiant Dawn)
----------------------------
[Fixed] Corrected the display of progress information (previously misplaced)
[Fixed] Changed default audio encoder from Nero AAC to FFmpeg AAC
[Fixed] Resolved crash issue when selecting Output Format
[Fixed] Ensured media information is correctly set from the original media file
[Update] Updated SVT-AV1 to version 2.1.2-15-gb8d2f2b4, using GCC 14.1.0 instead of VS2022

Version 8.2.9 (Stellar Harmony)
-------------------------------
[New] You can now set Format Output, Video, and Audio settings before importing media files. These settings will be used as the default when importing.
[New] Added Fraunhofer H.266/VVC Encoder for experimental (mp4 only)
[Fixed] The GUI now correctly shows MP4 when MP4 is selected as the Format Output, instead of incorrectly showing MKV.
[Fixed] FDK AAC HE_v2 now properly handles audio channels: it only supports stereo, so mono audio will be up-mixed to stereo and multi-channel audio will be down-mixed to stereo.
[Update] Improve video encoding progress

Version 8.2.8 (Ätherisches Licht)
---------------------------------
[New] Introduced support for USAC (Unified Speech and Audio Coding)!
[Fixed] Audio encoders that don't support multi-channel will now automatically downmix to stereo.
[Fixed] Added support for "Auto" audio sample rate in the Plugin Definition File. Setting it to 0 now means Auto.
[Fixed] Ensured default audio sample rate and channel values are always included in their lists. This helps avoid issues with missing default values and improves the reliability of audio settings.
[Change] Updated to use FFmpeg from Anim Mouse (build git-2024-06-26-1080116), which includes non-free encoders.
[Info] Special thanks to GitHub user @longwu9t for reporting these bugs and suggesting USAC support for Internet Friendly Media Encoder (IFME).

Version 8.2.7 (Leuchtendes Echo)
--------------------------------
[Info] This is beta/pre-relase was mistaken for public when fixing

Version 8.2.6 (Luminous Echo)
-----------------------------
[Fixed] The audio mode selection controls `cboAudioMode_SelectedIndexChanged();` were not updating other audio properties correctly when the audio mode was changed. Now, when the audio mode is changed, the quality, sample rate, and channel selections are properly updated and reflected in the encoding settings.

Version 8.2.5 (Aurora Serenade)
-------------------------------
[Fixed] Controls were not reflecting changes in the GUI when modifying encoding settings. This issue has been resolved by adding the missing function call DisplayProperties_Video(); DisplayProperties_Audio();. Thanks to @longwu9t

Version 8.2.4 (Eclipsed Radiance)
---------------------------------
[Fixed] FFmpeg MediaInfo "File Path" print wrong character due to Windows Console in ANSI
[Fixed] Resolved an issue with ffprobe output parsing where Unicode characters in the JSON output were incorrectly encoded. This was achieved by setting the StandardOutputEncoding property to Encoding.UTF8 in the ProcessStartInfo configuration.

Version 8.2.3 (Luminous Horizon)
--------------------------------
[Fixed] Multipass encoding was halting at the 2nd pass due to an incorrect frame count. Now, Multipass encoding will ignore the frame count, resulting in no ETA. (Note: This issue might be resolved in the future by indexing video frames first to determine the actual frame count.)

Version 8.2.2 (Mondnachtmelodie)
--------------------------------
[Fixed] Media files no longer default to MKV upon import; they now follow the currently selected output format container.
[Fixed] Non-MP4 and non-MKV format containers (e.g., AVI) always burning subtitles by default
[Fixed] Bug fix on multiple subs from another video that only extract once
[Update] Added subtitle support for MP4 containers (SRT, VTT). Issue #228 found by @longwu9t
[Update] Updated x265 to 3.6+27-8787e8702 (master branch)

Version 8.2.1 (Himmelsreise)
----------------------------
[New] Added VVC Encoder (uvg266 version 0.8.0) for experimental requests, issue #227
[Dev] MKV container currently gives an incorrect VVC FourCC to the player (shows as V_QUICKTIME), causing video playback issues. MP4, TS, and M2TS are working correctly for now.
[Update] Updated FFmpeg to 2024-06-16 to support VVC bitstream
[Update] Updated MP4Box to 2.4.0 to support VVC bitstream
[Update] Updated Rigaya NVEnc to 7.54

Version 8.2 (Mondscheinmärchen)
-------------------------------
[Fixed] Resolved GitHub issue #226: "Unrecognized option 'cqp'" error encountered when utilizing H.265 FFmpeg AMD AMF with Constant Quantization Parameter.
[Fixed] Corrected encoding extraction when importing video files into subtitle/attachment, ensuring accurate remuxing without compromising existing subtitle/attachment data from other videos.
[Update] Updated Rigaya Nvidia Encoder to version 7.50.
[Update] Updated AVX2 x265 Encoder to version 3.5+119-e112940bb (GCC 13.2).

Version 8.1 (Celestial Equations)
--------------------------------
[New] Implemented a method to permanently embed subtitles into videos without requiring `fonts.conf`.
[Fixed] Resolved an issue with incorrect usage of `Newtonsoft.Json.dll` from NuGet, ensuring compatibility across systems and preventing JSON-related bugs.
[Fixed] Adjusted the default splash screen fade duration from 1ms to 5ms to accommodate faster computers where the quick fade was too abrupt.

Note: After many years in beta, IFME is now out of beta thanks to the discovery of a method for correctly embedding styled subtitles without the need for `fonts.conf`. This method was uncovered while examining Jellyfin FFmpeg Encoding logs. It may seem trivial, but previous search results often suggested using `fonts.conf`.

Version 8.0 beta 13 (Eternal Descent)
-------------------------------------
[New] Embrace the Breeze: Introducing automatic cropping and letterbox removal. This feature, independent of stream copy and video resolution, ensures a seamless cropping experience without resizing.

Version 8.0 beta 12 (Luminar Spectrum)
---------------------------------------
[Fixed] Precision Polishing: Corrected a minor typo in the Chroma Subsample Pixel (CSP) handling. The issue involved incorrectly appending the Bit Depth for non-YUV formats. Special thanks to Shiniori-raws for bringing this to our attention.
[Optimization] Cutting-Edge Performance: IFME now ships with AVX2-enabled encoders (x265, x264) for optimal utilization of modern processors such as AMD Ryzen, Threadripper, Epyc, or their Intel equivalents. Please note that this change may render IFME incompatible with non-AVX2 processors.

Version 8.0 beta 11 (Celestial Cascade)
---------------------------------------
[New] Welcome Rigaya NVEnc: Introducing Nvidia Video Encoder support for GPU-based video encoding.
[Fixed] Progress in Motion: Now seamlessly integrates Rigaya NVEnc console output into the status display for a more comprehensive monitoring experience.

[Note] Rigaya's Contribution: Rigaya has also developed Intel Quick Sync and AMD VCE plugins, though we couldn't add support in this release due to a lack of hardware for validation. Feel free to explore the plugins in `Plugins\rigaya_nvencc\_plugin.video*` and make replacements as needed.

Version 8.0 beta 10 (Digital Horizon Symphony)
----------------------------------------------
[New] Introducing the "original" option in the Combo Box List; selecting it will use the original value.
[Fixed] Addressed conflicts with the "-vf" filter when applying crop operations.
[Fixed] Clarified the functionality of "auto" resolution, now truly adaptive based on the "-vf" or any specified parameters.
[Fixed] Resolved an issue where, if the FFmpeg "-vf" contained the "crop" parameter, the resolution would be set to "auto."

Note: This changelog is improved by OpenAI ChatGPT from my broken English input.

Version 8.0 beta 9 (Enigma Ascension)
-------------------------------------
[New] IFME now capable to become a Ingest Station Server where IFME watch the folder for any new file and encode based on user settings
[Fixed] Fix issue where user change format container cause Video/Audio Encoder to reset and override user value even container is compatible
[Fixed] Remove ToolTip "Inconsistent output format!"

Version 8.0 beta 8 (Night Princess)
-----------------------------------
[Fixed] Addressed a problem with the "Trim Video" input. Instead of validating the input during text changes, validation now occurs when leaving the TextBox control.
[Fixed] The "HardSub" CheckBox control now correctly displays the current status (Enable/Disable) of the selected video.

Version 8.0 beta 7 (Realize Maze)
---------------------------------
[Fixed] Renamed the label "Fast Remux" to "Smart Stream Copy" to reduce confusion among users when attempting to copy streams.

Version 8.0 beta 6 (Tearful)
----------------------------
[Fixed] Corrected the data type issue (float instead of int) for the total frame command.

Version 8.0 beta 5 (Mana)
-------------------------
[New] Expanded hardware acceleration support, including Intel Quick Sync (av1, h265, h264, vp9), Nvidia NVENC (h264, h265, av1), and AMD AMF (h264, h265).
[New] Added filename examples to demonstrate the final name when using Prefix and Postfix, making it easier for users to understand the naming convention.
[Fixed] Eliminated spaces in Postfix filenames.
[Fixed] Enabled a factory reset option for users to reset settings.
[Fixed] Resolved an issue (issue #223 reported by MrxHellsing) related to program hang caused by auto values.

Version 8.0 beta 4 (Prolog auf Erden)
-------------------------------------
[New] Introduced AV1 NVENC support in test mode, although testing was limited due to a lack of suitable hardware for encoding and quality adjustment.
[Update] Updated FFmpeg to BtbN builds, version N-109027-g202b7a9ae7 (shared, GPL).

Version 8.0 beta 3 (Kurzes Epos)
--------------------------------
[Fixed] Addressed IFME crashes on certain computers due to "Tabs Init" occurring before WinForm loading, causing different behavior when run via VS IDE and Standalone.
[Fixed] Allowed "Fast Remux" to work alongside "Trim"; when "Trim" is in use, it no longer skips the "Fast Remux" process.
[Fixed] Enabled "Fast Remux" to work with "Image Sequence."
[Fixed] Fixed issues related to Plugins Init (Test Encoder) with incorrect exit codes, ensuring proper encoder usage.
[Change] Modified Plugins Init (Test Encoder) to skip CPU encoders and test only GPU encoders unless "TestRequired" is set to true.
[Change] Made AV1 show total progress, enabling IFME to display the overall completion percentage.
[Change] Rearranged AV1 presets in reverse order, similar to x265 and x264, with the last item indicating slower encoding for higher quality and lower bit-rate.
[Update] Errors during plugins initialization are now shown in the log instead of the Splash Screen.

Version 8.0 beta 2 (Aufbruch)
-----------------------------
[Change] Metadata about "Writing Application" now displays IFME version, platform, and CPU architecture, making it easier to troubleshoot issues related to encoding versions.

Version 8.0 beta 1 (Erdentempel)
--------------------------------
[New] Introduced "Fast Remux" feature, allowing users to remux files when the codec is compatible with the target file container. Otherwise, it encodes to a compatible codec. Useful for cases where a wrong codec (e.g., AVI) in Jellyfin/Plex is encoded to H.264.
[New] Enabled folder import functionality for scanning and importing all Jellyfin/Plex media.
[Fixed] Refined the interpretation of FFmpeg return codes, where IFME now treats positive 1 as OK or a warning.
[Change] Deprecated "Copy Stream" due to the addition of the "Fast Remux" feature.
[Change] No longer ships CPU-specific x264/x265 encoders, as non-AVX processors cannot use them.
[Update] Updated x264 to version 3.5+56-8c159ba54.
[Update] Updated x265 to version 0.164.3094.
[Update] Updated SVT AV1 to version 1.3.0.
[Update] Updated FFmpeg to version 2022-10-27-git-00b03331a0-full.

It's been a while since IFME was under ALPHA release. I was concerned about potential bugs that might have gone unnoticed during testing. Now, IFME has entered the BETA stage, and all bugs and GUI glitches have been ironed out. I hope it functions as expected.

Furthermore, this 8th iteration of rebuilding the GUI from scratch has made it incompatible with previous versions. I understand that I'm not a professional programmer, but I've done my best. Sometimes, I get confused by FFmpeg's exit codes, as they can return random positive numbers. I recently discovered that the exit code reflects the total number of processed frames. All these years, I've been mistaken. I've realized that trying to understand FFmpeg's code on my own, without seeking help, was a bad idea. I'm not sure where to turn for assistance, and I'm afraid the community might become frustrated with my inquiries.


Version 22.01.18 Alpha (True Eternity)
--------------------------------------
[fixed] Wrong interpretation of FFmpeg return code, negative means error/something bad, positive means ok/warning.
[fixed] Multipass for x265 (dirty fix)

Version 22.01.02 Alpha (True Eternity)
--------------------------------------
[fixed] Hard Sub with MKV cause wrong data because previous subtitle and fonts copied over
[fixed] Extra space when Pre/Post fix in file name
[change] Invalid progress when using Trim, IFME automatically calculate with 2 second buffer (total length * frame rate) + frame rate * 2

NOTE!!! Trim not work on subtitles, you need to burn it.

Version 21.09.30 Alpha (Grus Nivis Chapter)
-------------------------------------------
[fixed] Project Angel (Siglus) reported Attachment Tab has broken behaviour and not update data properly.
[Tested] Image Sequence import has reached stable, no further development

NOTE!!! Decoder Encoder are not updated, currently has no issue to replace, you can override bundled tools


Version 21.06.17 Alpha (Undomesticated equines could not remove me.)
--------------------------------------------------------------------
[new] Option window is now available [git#218]
[new] Undesire encoders now can disable/enable [git#218]
[new] Allow user to disable encoder test just to make program start faster (use at own risk) [git#218]
[fixed] Cut video & audio with milisecond precision
[fixed] Prevent Image Sequence from selecting "Copy Stream [No Encoding]"
[fixed] Rate Factor & Multi Pass value not updated in certain edit (eg: typing value) [git#218]
[change] Audio Copy Stream checkbox replaced with Drop Down List and become default [git#218]
[change] x265 & x264 tune default to SSIM instead of PSNR, better visual quality. [git#218]


Version 21.06.14 Alpha (The galaxy is at a crossroads)
------------------------------------------------------
I sorry for very quick update, sometime designing GUI event can be daunting
[new] About IFME added for more information about this project
[fixed] Image Sequence source frame rate -to- output frame rate
[fixed] Adding additional streams did not show new item in the list [git#217]
[fixed] Stealing subtitle/attachment from other video file is possible

[support] Discord Server invite link available in "About IFME"
-

Version 21.06.13 Alpha (The galaxy is at a crossroads)
------------------------------------------------------
[update] This is pre-release version 8 beta, still many missing feature...
[new] Support Image Sequence (right click + button)
[new] Support H.263/XVID encode for older device
[new] Support VP8 & VP9 encode for internet
[fixed] Encoding bug did not remux for final files
[fixed] Various code fix
[fixed] Cut loading/testing time (using small sample file) for weak computers
[update] Multiple x265 cpu arch support (avx2, avx, sse) for efficient encoding
[update] Multiple x264 cpu arch support (avx2, sse) for efficient encoding
[update] IFME will try which cpu arch supported during loading

NOTE!!! 32-bit OS is experimental and drop in the future release

Version 21.05.25 Alpha (One More Time)
--------------------------------------
[new] Hardware Acceleration for Nvidia (NVENC)
[new] Hardware Acceleration for AMD Advanced Media Framework
[fixed] GUI Control bug on Bit Depth
[fixed] GUI Control bug on ListViewItem during Selection
[fixed] GUI Control bug on various stuff
[fixed] Opus sample rate, only 48000Hz valid
[change] IFME will test encoders plugins during loading, incompatible will not added into ComboBox list
[update] x265 version 3.5+10-82786fccc
[update] ffmpeg 64-bit 2021-05-23-git-4c0d6c91f6
[update] ffmpeg 32-bit 4.3.1 (Final version for ancient pc)

Version 20.05.2 Alpha (Always remember why you started)
-------------------------------------------------------
[new] Updated banner
[new] Realtime progress and status (no more print multiple line of progress)
[new] Windows: File size now in IEC Standard (/1024, International Electrotechnical Commission)
[new] Unix: File size now in Metric Standard (/1000)
[new] Add new Nero AAC audio encoder!
[fixed] Static Build: MP4Box
[fixed] Static Build: x264 Encoder (this will rarely update)
[fixed] Able to extract and embed BDMV Subtitle
[fixed] Various GUI bug, take note that burn subtitle not working at the moment
[fixed] Decimal separator problem (some country use , instead of .)


Version 20.04.2 Alpha (Darkness to Light)
---------------------------------------------------
[new] Advance Decoding/Encoding CLI button is functional
[new] Profile is functional as well
[new] New check box for Shutdown
[new] HDR to SDR profiles, allow you to high quality downscale
[fixed] High quality downscale resolution
[fixed] Various GUI bug
[fixed] Null Language in FFmpeg Media Info (default to "und")
[mistake] x265 in previous version was 3.2, now with 3.3 stable

Version 20.04.1 Alpha (The Quintessence Inside You)
-------------------------------------------------
This whole new version which is rebuild from scratch.
Fix most problematic since release 7.7!
[new] Using latest .NET 4.8
[issue] Windows run fine, Linux not test yet.
[change] Console now inside interface, no longer produce two window

Version 7.8 (Opera Fantasia)
----------------------------
[new] Able to capture language code from file name (Subtitle)
[fixed] Encoding did not honor "Main List Check State" (able to skip item)
[fixed] Default codecs for new import media

Version 7.7 (Prism Ark)
-----------------------
[new] Enable/Disable verbose log
[fixed] Broken version detection that always return true.
[fixed] Prevent save a blank project.
[fixed] Make a duplicate file if exist. example: File Name (1).mkv

Version 7.6 (Soul Heart)
------------------------
[new] Support Burn subtitle into video (Hard Sub) [FFmpeg with --libass enable]
[new] Add folder import (recursively find media file)
[new] Queue/List now can save just like previous version
[new] Added legacy codec for older device support
[new] Added M2TS output support
[fixed] Plugins script: value now can have prefix & postfix (eg: 128k instead of 128000)
[fixed] Audio channel now give meaningful text instead of numbers
[fixed] Media settings cannot save (revert to default) when select different target format item
[change] Update x265 version 2.6+13 (64-bit only)
[change] Rename included preset to friendly name :)
[chnage] More branding support
[change] Target Format now using "DropDown" selection

NOTE: Previous version Encoding Preset script cannot work in this new version, please edit before use.

Version 7.5 (Cosmic Housekeeping)
---------------------------------
[new] Support Trim Video & Audio
[new] Support adding FFmpeg command for decoding
[new] Brazilian Portuguese localisation #138
[change] Add Mkvtoolnix back (chapter support)
[change] Default window size change to 900x700 (Monitor 1024x760 minimum)

Version 7.4 (Endless Sky)
-------------------------
[new] Arabic localistion
[new] Russian localisation #131
[fixed] Redundant chapters on each stream (keep only one)
[fixed] encoded x264 not merge in MP4 files
[fixed] Invalid FFmpeg Probe ISO639-2 Language Code #132
[fixed] (UX) Target Format not updated when change
[fixed] Using FFmpeg to merge files if mkvmerge fails
[fixed] If Destination Path is blank or invalid, all video will be save where source file is #133
[fixed] Added Keyboard shortcut (CTRL+A) and (DEL) for listing items #134
[fixed] Out of Index bug on Attachment lists
[change] Latest encoding preset will be first item
[change] No longer use MP4Box & Mkvtoolnix for muxing files
[change] Any raw video file will be processed with MP4Box first
[update] x265 version 2.5+11

Version 7.3 (These Final Words)
-------------------------------
[new] Support 32-bit computer for older tech (yet, high bit-depth require 64-bit OS)
[new] German localisation #126
[new] Italian localisation
[new] French localisation #124
[add] Multi-pass encoding now display how many pass need to finished
[add] New version column for Modules at Option Window
[add] Non intrusive error message by adding OS default system sounds
[add] Allow to steal font (attachment) from another video :)
[fixed] English Grammar #128
[fixed] If import video has 10 bit, but encoder dont have 10 bit, revert to 8 bit
[fixed] Video plugin definition file, preset and tune now have off/disable entry #127
[fixed] Custom command-line missing from video encoding
[fixed] Change different encoder cause wrong "extra command-line"
[fixed] Relative path for Windows XP
[fixed] Output folder require full path
[fixed] Sorted Mime Type, allow user to edit
[change] Default Windows size from 800x600 to 900x650
[change] Banner drawing error tag change to warning tag
[change] Improve encoding queue code
[change] Able to detect 64-bit AviSynth & AviSynth+
[update] FFmpeg Windows amd64 build 2017/06/20
[update] FFmpeg Windows i686 build 3.1.2
[update] FFmpeg Linux build 2017/06/19
[update] MP4Box version 0.7.0
[update] Mkvtoolnix version 13.0.0
[update] x264 version r2851
[update] x265 version 2.4+89

Version 7.2 (Enchantress)
-------------------------
[add] Added new command-line -r (--reset) for reset IFME settings to default configuration
[add] Print command-line every encoding (like IFME version 3)
[fixed] Live update for Encoding Preset listing
[fixed] Changing Rate Control cause current value not in range
[fixed] Remove frame count detection for Multi-pass encoding (avoid inconsistent frame)
[change] FFmpeg verbose "panic" to "error"

Version 7.1 (Free and Independent)
----------------------------------
[new] Merge failover (if merge fails, IFME will copy whole thing to save folder)
[new] Sub Menu for New/Import, Save encoding presets
[fixed] Multi Pass encoding

Version 7.0 (Eridanus)
----------------------
[new] Complete re-write new code, all bug has has been fixed!
[new] Allow audio only encoding
[remove] CPU Affinity & Priority
[remove] AviSynth Editor & Extensions
[change] Using JSON instead of INI
[change] No longer preserve variable frame rate

Version 6.1 (Pixelaphobia)
--------------------------
[fixed] Skip missing plugin executable file
[fixed] Skip invalid plugin GUID
[fixed] Only Variable Frame Rate timecode indexing

Version 6.0 (Archangel Descending)
----------------------------------
[new] Allow user to save encoded file either same source folder or given path
[new] Capable to encode audio files, but not fully supported
[added] Language: Italian
[added] Language: Lithuanian (Git #77)
[added] Allow user to add FFmpeg arguments/command-line
[added] Allow user to edit/rename Encoding Preset (Git #55)
[added] Allow user to delete Encoding Preset (Git #55)
[added] Allow user to delete queue by pressing DEL key (Git #55)
[added] Allow user to add more Audio track
[added] Allow TTC (TrueType Font Collection) to be embedded
[added] Allow user to remove embeded subtitles
[fixed] CPU Affinity & Priority has been fix! [Windows] (Git #61)
[fixed] Download & Updater engine improved!
[fixed] Temp folder will clear after finished encoding, open & close program
[fixed] HEVC video passthrough not properly save
[fixed] Linux plugin is now statically linked (portable), thanks to darealshinji
[fixed] Invalid MKV language id (told by Nikolai Lyskov)
[fixed] Prevent copy audio tracks cause MKV chapter begin copied
[fixed] Queue item value on audio bit-rate, Freq, and Channel revert to default (Git #57)
[fixed] Remove 4GB wav limit, using pipe + header (Git #56)
[fixed] Missing translation strings
[fixed] better detecting media files inside AviSynth script (Git #54)
[fixed] WMA will force to AAC either MKV or MP4 (Git #51)
[fixed] Invalid language id become "und" (Git #62)
[fixed] In video tab, different mode cause set to default value.
[fixed] Faster loading time by adding "-s" as argument (skip update)
[fixed] AviSynth Trim command doesn't apply for audio (Git #65)
[change] Media Encoder engine improved
[change] Prefix [encoded] now changed to current date-time postfix (Git #68)
[change] Music removed for About IFME, not suitable for professional environment
[change] Updated ISO 639-2 language code
[change] Using FFmpeg to extract font files
[change] Using GUID rather then string equalities for Audio encoder (API change)
[change] Remove --force-avs command
[change] Allow AviSynth to use 10/12bit and YUV (Git #79)

Version 5.1 (FLUORITE DIARY)
-----------
[new] Adding 12bit encoding support!
[new] Audio tracks now can drop if not wanted to add final encoded file
[new] Video now can skip encoding (applicable when source is HEVC)
[new] --force-avs arguments for force AviSynth script added to queue (just in case IFME did not detect)
[fixed] Wrong extension file which is benchmark extension was a notepad
[fixed] MediaInfo didn't detect (Linux)
[fixed] Missing audio mixing
[fixed] Selecting profiles except "< new >" then add video result will follow profiles configuration
[fixed] Temp folder not removed when closing IFME
[fixed] Prevent empty string from launch a process/visit web
[fixed] Git issue #35 #36 #37 #38 (told by forkicks)
[fixed] Git issue #41 When type text into the ratefactor textbox, the characters are entered in the wrong order (told by forkicks)
[fixed] Unable to open "Option" window due to error
[fixed] Git issue #42, open queue list, which queue file not exist cause IFME to crash.
[fixed] Prevent user enter invalid input
[fixed] Prevent user add media via network location (\\PCNAME)
[fixed] Prevent user set output folder via network location (\\PCNAME)
[fixed] Git issue #45, destination folder path did not save
[fixed] Git issue #46 and #47

Version 5.0.9 (Dearness)
-------------
[fixed] Fix code mistake
[fixed] Mp4 did not mux audio when do pass-through
[added] Language: Čeština
[added] Language: Français
[added] Language: Português
[added] Language: Deutsche

Version 5.0.8 (True My Heart)
-------------
[new] Allow user to save queue list
[new] Command-line encoding via queue file

Version 5.0.7 (Twin Angel)
-------------
[new] Linux support (native)
[new] Windows 32bit support
[fixed] Subtitle did not extract
[fixed] Form did not aligned properly on Linux

Version 5.0.6.1 (Twin Angel)
---------------
Welcome to IFME Go aka version 5, feel queue encoding.

[new] Re-write code, better & faster
[new] Simple User Interface yet better
[new] IFME 3.x Console style is back, low RAM usage
[new] Extension support, allow extend IFME capabilities
[new] x265 compiled binary of choice
[new] Benchmark for testing CPU and x265 compiled
[new] AviSynth installation status
[fixed] No longer 1 subtitle per video
[fixed] No longer 1 font collection for all video
[added] Native AviSynth support
[added] "auto" resolution and frame rate
[change] Addons API
[change] Profiles API
[issue] Multi-language not yet implemented


Version 4.10 (Twin Angel)
------------
[fixed] Accepting longer file name and path
[fixed] 10 bit become 8 bit due to wrong pixel format
[added] AviSynth Support (Windows only)
[added] InterFrame/HFR conversion support via AviSynth
[added] Image sequence conversion support via AviSynth
[added] Image sequence conversion support via IFME Script
[added] Image sequence generator
[added] Allow user to change "[encoded]" tag
[change] 720x400 to 720x404

Version 4.9.4.0 (Unending Love)
---------------
[fixed] settings cannot be saved, last configuration moved to user preset
[fixed] video out of sync issue where video having "original frame rate" bug.
[fixed] Shutdown checkbox settings not saved properly.
[fixed] Shutdown checkbox not suppose to disable all of time
[fixed] mkvtoolnix warning as error cause encoding stop, now mark as OK.
[fixed] Multi-pass isssue
[added] Traditional Chinese
[change] Font "Consolas" not shipped by default Windows install, changed to "Lucida Console"

Version 4.9.3.0
---------------
[fixed] Half way encoding (decoder issue)
[fixed] Failed to read stream mapping
[fixed] Ask updater not to delete, just overwrite.

Version 4.9.2.0
---------------
[added] News function, not critial.
[fixed] Interlaced video cannot execute preview mode
[fixed] Did not remove all multiple selected item in queue (issue: http://goo.gl/bgtmGs)
[fixed] Improper reading media mapping
[fixed] Log now can safe in RTF formatted, retaining colour and so-on...
[change] info,ok,warn,error change to Timestamps with colour, providing acurate debugging.

Version 4.9.1.0
---------------
[fixed] Variable Frame Rate did not sync properly
[fixed] Temp file not remove when cancel encoding job
[fixed] Skip addons version check if no server url provided
[fixed] Program crash cause audio addons removed, invalid index issue
[fixed] Multipass mode did not encode
[fixed] Bitrate mode did not encode
[fixed] QP mode did not encode

Version 4.9.0.0
---------------
[added] Preview feature, allow user sneak peek before commit full encoding
[added] User preset, allow user to save and load config
[added] Missing auto save log each conversion
[added] Russian Language by zetcamp
[added] Turkish Language by SailorOnDaTea
[fixed] Video cannot encode due to AVI indexing problem
[fixed] Broken update under Linux (missing "./")
[fixed] Cannot encode video that has no audio
[fixed] IFME MKV output now will not write Tag and Statistics
[fixed] Update system that cause delete addons when download a 1kb file of 404 error
[fixed] Wrong button position at Option > Perf. under Linux
[fixed] MKV archive extract command
[change] Splash Screen
[improve] Simplified and optimized get current UI language query.
[improve] Disable/Enable TAB page code has been improved (iteration removed)

Version 4.8.0.0
---------------
From here, IFME change new icon again.

[added] Italian translation by MatrixG
[added] Multiple pass encoding support up to 8 passes
[added] Function to change video resolution
[fixed] Improper MKV extraction and repacking
[fixed] About Dialog, file size shirnk by ~4%

Version 4.7.4.0
---------------
From here, IFME changed to new flat design icon.

[added] German translation by Criz
[added] Greek translation by mikroner
[added] Arabic translation by Ani Moy (The Leader)
[added] Spanish translation by Francisco Pozo 'DJ FrANKy EHP
[fixed] Missing temporary folder check, reported by: fb.com/RainOfHappiness


Version 4.7.3.0
---------------
[fixed] ISP (Telekom Malaysia) corrupted my package during upload
[improve] Program optimisation

Version 4.7.2.0
---------------
[fixed] Audio encoder not encoding after decoding...
[update] Improved Vietnam Language

Version 4.7.1.0
---------------
[fixed] Format detection in "Audio passthrough" and support more format
[fixed] Pause/Resume button on stop

Version 4.7.0.0
---------------
Version 4.6 have auto update issue, please download manually.

[added] Audio passthrough feature (suggestion by @thefinaldegree)
[fixed] Video encoder didn't report progress [Windows]
[fixed] File exist issue where MP4 output selected [Both]
[fixed] Delay instant shutdown after complete encoding, put 3 second delay [Windows]
[fixed] Language detection, using "und" instead of empty string [Both]
[fixed] Auto update didn't fetch new version [Both]

Version 4.6.0.0
---------------
Introducing IFME for Linux (4.5 -> 4.6)

[added] Shutdown feature when encoding job completed [Windows] (suggestion by Neil N. Prasad)
[added] Allow manually adjust value for Rate-control [Both]
[fixed] Rate-control value saved in wrong data type, int < float [Both]
[fixed] Command-line too long [Windows]
[improve] Program update, update will choose best CDN (using wget) [Both]
[improve] MediaInfo video frame now store in unsigned 64bit integer [Both]

Version 4.5.0.0
---------------
There huge improvment could't list, here some of it:
New IFME mascot illustrated by ray-en, refer "About" window for more info.

[fixed] Bug that reset setting wont reset properly.
[fixed] FPS detection, since Y4M did contain Metadata, x265 can read.
[added] Missing x265 "superfast" preset.
[added] Missing x265 tuning, now can disable/off due some player dont like it.
[added] VFR support without duplicate or remove frame (Excact copy)
[added] Deinterlaced support by detecting, deinterlace processing quality based on x265 preset.
[added] Brazilian Portuguese language by Elmapul.
[added] Japanese language by Yukipone.
[improve] IFME updating, when got new version, checking addon version will skip (increase load time)

Version 4.0.0.4
---------------
[fixed] Issue where attachment cause video encoding to fail
[fixed] Issue when user disable update check, result addons not load.
[fixed] Issue where user in full screen not able back to window mode with previous size.
[added] Indonesia language (by Sandy Nicko Mac Corzeta)
[added] Function where console now capable to save log and clear
[update] Console font (now use Consolas)
[improve] File and media validation and some small change...

Version 4.0.0.3
---------------
[fixed] Issue where MP4 video not saved, reported by webvid md and LaruYan
[fixed] Resolved issue where stop button goes missing when you maximize window. (GitHub by HeHeHunter)
[added] Drag n Drop for Subtitle and Attachment
[improve] Chinese Language UI, mistake has been corrected (by LEaver)
[improve] Optimized loading by delaying loading of languages and addons. (GitHub by HeHeHunter)
[improve] Start button will only be enabled when media is added, disabled when there is no media. Reduce Error Prompt. (GitHub by HeHeHunter)

Version 4.0.0.2
---------------
[fixed] "Pause" button not hide after stop encoding
[fixed] Audio encoding mode where audio ID in wrong place
[improve] Splash Screen, displaying download progress
[improve] Chinese Simplified UI Language.

Version 4.0.0.1
---------------
[fixed] Updater issue!!!
[fixed] That Subtitle and Attachment blocking encoding process
[fixed] That button acting weird
[fixed] Update balloon message

Version 4.0.0.0
---------------
Totally re-write new code and stuff

[added] Multi-language file using ISO standard, now can be editable
[added] Function addons/plugins, you can add your own stuff too!
[added] Function auto-update each installed encoder
[added] CPU Affinity! You can encode on specific CPU core!
[added] CPU Priority, encode which level as you want!
[remove] DVD-Rip support
[remove] Command prompt/DOS window
[remove] CPU Instruction Set

Version 3.2.1.0
---------------
[update] x265 (1.0+139-a5998df9b12e)
[added] Dithering option

Version 3.2.0.0
---------------
[update] x265 (0.9+134-f3585fd81c3b)
[update] mp4box (0.5.1)
[added] Realtime video decoding-encoding!
[fixed] DVD RIP encoding
[remove] video decoding process!

Version 3.1.0.6
---------------
[update] x265 (0.9+126-4f7658b3c78a)

Version 3.1.0.5
---------------
[update] x265 (0.9+19-b5caca9954f3)
[added] DVD RIP support
[added] CPU Instruction Set support

Version 3.1.0.4
---------------
[update] x265 (0.7+289-734f106295df)

Version 3.1.0.3
---------------
Now opus will be default audio encoder for MKV

[update] x265 (0.7+59-def14c0234f5)
[update] Opus (tool 0.1.8/lib 1.1)
[fixed] Norwegian grammar mistake's
[fixed] Termination bug on 10bit encoding

Version 3.1.0.2
---------------
[update]x265 (0.6+335-3568c1b19947)
[added]Support OpenType Font and Web Open Font Format

Version 3.1.0.1
---------------
[update] x265 (0.6+284-c88314c4a1a1)
[fixed] Language glitch cause attachment become buggy making MKV not process properly!

Version 3.1.0.0
---------------
[update] x265 (0.6+282-385560ac328d)
[added] Multi language support for first time!
[added] Chinese Simplified by LEaver.
[added] Indonesian by Sandy Nicko Mac Corzeta
[added] Japanese (machine translated)
[added] Malaysia by Omamori Himari
[added] Norwegian by Christoffer Boothby

Version 3.0.0.3
---------------
Note: IFME always use 8 bit encoding even 10 bit input will encoded into 8 bit, due to "high bit depth" not yet fully optimized for performance. This can be adjust on "Advanced" tab by enable "use auto detect" or choose 10 bit, force 10 bit also cause 8 bit input will encoded into 10 bit, suggested to use auto detect!

[update]x265 (0.6+262-b2e7d8da2838)
[added] Reset settings to default, suggested by Danny Sabrak. 
[added] New video tuning "zero-latency"
[added] New video property on advanced tab
[added] 10 bit encoding support, default 8 bit.
[fixed] MediaInfo give invalid fps, thanks Christoffer Boothby!

Version 3.0.0.2
---------------
[update] x265 (0.6+241-99f28c405b5c)
[change] Default CRF\QP value to 26 (50:50)
[added] Feature multiple select and [remove]
[added] Feature where queue will highlight where media file done encoding.
[added] Function where window control get disabled when encoding in progress.
[fixed] Video configuration due to CRF only even choose different option.
[fixed] Total encoding time, missing day(s).
[fixed] Queue button (move down).
[fixed] Program quit when encoding in progress, unload component from process before exit
[remove] Taskbar balloon, due icon stuck when application close.

Version 3.0.0.1
---------------
Starting here, only 64bit supported and .NET Framework 4.0 build.

[update] x265 (0.6+240-f96c85f03b77)
[update] Console splash screen
[added] Experimental support for subtitle and font (attachment)
[added] Override MediaInfo detection (fps override)
[fixed] MKV command for video only encoding.

Version 3.0.0.0
---------------
[change] Debug console to Windows Console mode.
[remove] Support separate stream encoding
[added] Support multiple audio stream, able to merge or multi stream

Version 2.0.2.3
---------------
[fixed] Code bug

Version 2.0.2.2
---------------
[added] Splash Screen for component startup and update check

Version 2.0.2.1
---------------
[added] Auto update support

Version 2.0.0.0 - 2.0.1.1
-------------------------
[added] Feature debug console
[added] Feature queue encoding!
[fixed] Code and improvement!

Version 1.0.0.0
---------------
IFME was born at 30 September 2013